property pSprite, pStart, pEnd, pDir, pDistance, pRate

on beginSprite me
  pSprite = sprite(the currentSpriteNum)
  pStart = pSprite.locH
  pEnd = pStart + pDistance
  pDir = 1
  add(the actorList, pSprite)
end

on stepFrame me
  curLoc = pSprite.locH
  if curLoc > pEnd then
    pDir = 0
  else
    if curLoc < pStart then
      pDir = 1
    end if
  end if
  if pDir then
    pSprite.locH = curLoc + pRate
  else
    pSprite.locH = curLoc - pRate
  end if
end

on endSprite me
  (the actorList).deleteOne(pSprite)
end

on getPropertyDescriptionList
  pList = [:]
  addProp(pList, #pDistance, [#comment: "move distance: ", #format: #integer, #default: 30, #range: [#min: 0, #max: 800]])
  addProp(pList, #pRate, [#comment: "rate (pix per frame): ", #format: #integer, #default: 2, #range: [#min: 1, #max: 20]])
  return pList
end
