property pSprite, pDuration, pSliderSprite, pOldSliderSprite

on getBehaviorDescription
  return "QuickTime Control Slider" & RETURN & RETURN & "Use this behavior in conjunction with the Animation: Interactive 'Constrain to Line' behavior to create a slider control for QuickTime digital videos. " & "Attach the 'Constrain' behavior to the slider and set its parameters and put this behavior on the digital video sprite." & RETURN & RETURN & "PARAMETERS:" & RETURN & " - channel number of Slider sprite." & RETURN & RETURN & "PERMITTED TYPES:" & RETURN & "#QuickTimeMedia"
end

on getBehaviorTooltip me
  return "Use in conjunction with the Constrain to Line behavior (in the Animation > Interactive library) to create a slider that can respond to QuickTime playback."
end

on beginSprite me
  mInitialize(me)
end

on prepareFrame me
  mUpdate(me)
end

on mInitialize me
  pSprite = sprite(me.spriteNum)
  pDuration = pSprite.duration
end

on mUpdate
  vValue = float(pSprite.movieTime) / pDuration
  sendSprite(pSliderSprite, #mSetConstrainPos, vValue, 0)
end

on mConstrainedValue me, vSlider, vValue
  if vSlider = pSliderSprite then
    pSprite.movieTime = integer(pDuration * vValue)
  end if
end

on changeSlider me
  pSliderSprite = 101
  mInitialize(me)
end

on isOKToAttach me, aSpriteType, aSpriteNum
  case aSpriteType of
    #graphic:
      return getPos([#quickTimeMedia], sprite(aSpriteNum).member.type) <> 0
    #script:
      return 0
  end case
end

on getPropertyDescriptionList me
  if not (the currentSpriteNum) then
    exit
  end if
  vPDList = [:]
  setaProp(vPDList, #pSliderSprite, [#comment: "Slider Sprite", #format: #integer, #default: the currentSpriteNum + 1, #range: [#min: 1, #max: the lastChannel]])
  return vPDList
end
